/* .c                         freeware                 xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "xa_hfile.h"

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* Call  :                                                                    */
/* Debug :                                                                    */
/* -------------------------------------------------------------------------- */
AB(
int n,
int vectrow)
{
fraction f1by4      = {1,4};

fraction Norm_uplsv;
fraction Norm_umnsv;
fraction Norm_f1by4uplsv;
fraction Norm_f1by4umnsv;
fraction Norm_f1by4uplsv_mns_f1by4umnsv;

fraction InnerProduct;

double pbu    [MXR][MXC*TWOCOL];matrix mu    ={MXR,MXC*TWOCOL,&pbu    [0][0]};
double pbv    [MXR][MXC*TWOCOL];matrix mv    ={MXR,MXC*TWOCOL,&pbv    [0][0]};
double puplsv [MXR][MXC*TWOCOL];matrix muplsv={MXR, MXC*TWOCOL,&puplsv[0][0]};
double pumnsv [MXR][MXC*TWOCOL];matrix mumnsv={MXR, MXC*TWOCOL,&pumnsv[0][0]};

if     (vectrow)
  {
           mu.rows = 1;           mu.cols = n*TWOCOL;
           mv.rows = 1;           mv.cols = n*TWOCOL;
       muplsv.rows = 1;       muplsv.cols = n*TWOCOL;
       mumnsv.rows = 1;       mumnsv.cols = n*TWOCOL;
  }
else if(!vectrow)
   {
           mu.rows = n;           mu.cols = 1*TWOCOL;
           mv.rows = n;           mv.cols = 1*TWOCOL;
       muplsv.rows = n;       muplsv.cols = 1*TWOCOL;
       mumnsv.rows = n;       mumnsv.cols = 1*TWOCOL;
   }
/*-------------------------------- PROGRAM ---------------------------------- */
  rndmI(&mu,5);
  rndmI(&mv,5);

  clrscrn();

  printf("                                 u");
  printmI4(&mu);
  printf("                                 v");
  printmI4(&mv);

  addmF(&mu,&mv,&muplsv);
  printf("\n\n                             u + v");
  printmI4(&muplsv);

  Norm_uplsv = normP2(&muplsv);               /* It is the square of the norm.*/
  printf("\n\n         ||u + v||**2 = %.0lf\n",
            Norm_uplsv.numer);
  getchar();

  clrscrn();
  printf("                                 u");
  printmI4(&mu);
  printf("                                 v");
  printmI4(&mv);

  submF(&mu,&mv,&mumnsv);
  printf("\n\n                             u - v");
  printmI4(&mumnsv);

  Norm_umnsv = normP2(&mumnsv);               /* It is the square of the norm.*/
  printf("\n\n         ||u - v||**2 = %.0lf\n",
            Norm_umnsv.numer);
  getchar();


  clrscrn();

  printf("                           ||u + v||**2 = %.0lf\n\n",
            Norm_uplsv.numer);

  Norm_f1by4uplsv = multF(f1by4, Norm_uplsv);
  printf("                       1/4 ||u + v||**2 = %.0lf/%-.0lf\n\n\n",
            Norm_f1by4uplsv.numer,
            Norm_f1by4uplsv.denom);

  printf("                           ||u - v||**2 = %.0lf\n\n",
            Norm_umnsv.numer);

  Norm_f1by4umnsv = multF(f1by4, Norm_umnsv);
  printf("                       1/4 ||u - v||**2 = %.0lf/%-.0lf\n\n\n",
            Norm_f1by4umnsv.numer,
            Norm_f1by4umnsv.denom);

  printf("               If u and v are vector in R**n      \n");
  printf("              with the Euclidean inner product :\n\n");
  printf("      u.v = 1/4 ||u+v||**2  -  1/4 ||u-v||**2 \n\n\n");

  InnerProduct = innerprod(&mu,&mv);
  printf("                                    u.v = %.0lf\n\n",
            InnerProduct.numer);

  Norm_f1by4uplsv_mns_f1by4umnsv = subF(Norm_f1by4uplsv, Norm_f1by4umnsv);
  printf("  1/4 ||u + v||**2  -  1/4 ||u - v||**2 = %.0lf/%.0lf\n\n",
            Norm_f1by4uplsv_mns_f1by4umnsv.numer,
            Norm_f1by4uplsv_mns_f1by4umnsv.denom);
}

void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n\n\n      If u and v are vector in R**n           ");
  printf("\n    with the Euclidean inner product :          \n");
  printf("\n   u.v = 1/4 ||u+v||**2  -  1/4 ||u-v||**2        ");
  printf("\n   ***************************************    \n\n");
  printf("\n The size of u, v : 2x1 ... 4x1.                \n");
  printf("\n     ex : \"thuvCI.exe\"                        \n");
  printf("\n You can choose the size :                      \n");
  printf("\n     ex : \"thuvCI.exe 2\" -> 2x1                 ");
  printf("\n          \"thuvCI.exe 4\" -> 4x1               \n");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                          ");
  printf("\n                                                  ");
  getchar();
}


/* --------------------------------- MAIN ----------------------------------- */
int main(int argc, char *argv[])
{
time_t t;
int    n;
int    vectrow = 1;
/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{
if( argc == 2 && atoi(argv[1]) )
 {n = atoi(argv[1]); if( n > 5){n=5;}}
else
 {    n=rndpI(5);}
   if(n<2){n=2;}

if( vectrow){vectrow = 0;}
else        {vectrow = 1;}


  AB(n,vectrow);


  printf("\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}












